# coding: utf-8

from inspect import currentframe
import django


def is_in_migration_command():
    u"""Возвращает True, если код выполняется в рамках миграций Django.

    :rtype: bool
    """
    from django.core.management import ManagementUtility

    if django.VERSION < (1, 7):
        from south.management.commands.migrate import Command
    else:
        from django.core.management.commands.migrate import Command

    frame = currentframe()
    while frame:
        if 'self' in frame.f_locals:
            self_object = frame.f_locals['self']
            if isinstance(self_object, Command):
                return True

            elif isinstance(self_object, ManagementUtility):
                # Срабатывает при использовании функции в AppConfig
                if 'subcommand' in frame.f_locals:
                    subcommand = frame.f_locals['subcommand']
                    return subcommand == 'migrate'

        frame = frame.f_back

    return False
